import java.io.*;
import java.util.*;

public class SLOG_ProfileEntry
{
    public String  classtype;
    public String  label;
    public int     rectype;
    public String  color;
    public boolean is_var_irec;
    public int     Nassocs;
    public int     Nargs;

    public SLOG_ProfileEntry( String line )
    throws NoSuchElementException, IndexOutOfBoundsException
    {
        StringTokenizer token_strs = new StringTokenizer( line, " \t" );
        if ( token_strs.countTokens() == 7 ) {
            classtype   = token_strs.nextToken();
            label       = token_strs.nextToken();
            rectype     = Integer.parseInt( token_strs.nextToken() );
            color       = token_strs.nextToken();
            is_var_irec = token_strs.nextToken().equals( "true" ) ?
                          true : false;
            Nassocs     = Integer.parseInt( token_strs.nextToken() );
            Nargs       = Integer.parseInt( token_strs.nextToken() );
        }
        else
            throw new IndexOutOfBoundsException( "Incorrect number of tokens: " 
                                               + line );
    }

    public String toString()
    {
        StringBuffer representation = new StringBuffer();
        representation.append( classtype   + " " );
        representation.append( label       + " " );
        representation.append( rectype     + " " );
        representation.append( color       + " " );
        representation.append( is_var_irec + " " );
        representation.append( Nassocs     + " " );
        representation.append( Nargs       + " " );
        return representation.toString();
    }
}
