#include <stdio.h>
#include "slog.h"

#define  MaxAssocs 10
#define  MaxArgs   10

#define  NaN         0

void main( int argc, char **argv )
{
          char slog_name[80] = "slogfile.data";
          SLOG_STREAM     *slog;
    const SLOG_intvlrec_t *const_irec;
          SLOG_intvlrec_t *irec;
          int              MaxIrec;
          int ii, Nargs, ierr;

    if ( argc > 1 ) {
        printf( "argv[1] = _%s_\n", argv[1] );
        if ( isalpha( argv[1][0] ) )
            strcpy( slog_name, argv[1] );
    }

    slog = SLOG_OpenInputStream( slog_name );
    if ( slog == NULL ) {
        printf( "SLOG_OpenInputStream() returns NULL\n" );
        exit(1);
    }

    printf("\n" );
    printf( "The Interval Record Definition Table :\n" );
    SLOG_STM_PrintRecDefs( slog, stdout );
    printf( "\n" );

    printf( "The Frame Directory Header:\n" );
    SLOG_STM_PrintFrameDirHdr( slog, stdout );
    
    printf( "The Frame Directory Non-empty Entries:\n" );
    SLOG_STM_PrintFrameDirEntries( slog, stdout );
    printf( "\n" );

    printf( "Start reading records :\n" );

    if ( 1 ) {
        MaxIrec = 0;
        while( ( const_irec  = SLOG_Irec_FromInputStream( slog, &ierr ) ) 
                            != NULL ) {
            printf( "%d: ", MaxIrec );
            irec = SLOG_Irec_Copy( const_irec );
            SLOG_Irec_Print( irec, stdout ); fprintf( stdout, "\n" );
            SLOG_Irec_Free( irec );
            MaxIrec++;
        }
    }
    else {
        MaxIrec = 0;
        while( ( const_irec  = SLOG_Irec_FromInputStream( slog, &ierr ) ) 
                            != NULL ) {
            printf( "%d: ", MaxIrec );
            SLOG_Irec_Print( const_irec, stdout ); fprintf( stdout, "\n" );
            MaxIrec++;
        }
    }

    printf( "Finish appending records :\n" );

    SLOG_CloseInputStream( slog );
}
