#include <ctype.h>
#include <stdio.h>
#include "slog_recdefs.h"

#if 0
#define  MaxAssocs  4
#define  MaxArgs    6
#else
#define  MaxAssocs  0
#define  MaxArgs    0
#endif

SLOG_rectype_t GetRecType( const SLOG_uint32 IdxType,
                           const SLOG_uint32 IdxAssocs,
                           const SLOG_uint32 IdxArgs )
{
    const unsigned int    UnitType       = 100;
    const unsigned int    UnitAssocs     = 10;
    const unsigned int    UnitArgs       = 1;
    /*  May want to check if UnitXXXX is in the correct range  */
    return ( IdxType * UnitType + IdxAssocs * UnitAssocs + IdxArgs * UnitArgs );
}

main( int argc, char **argv )
{
    char  filename[] = SLOG_RECDEFFILE;

    const SLOG_rectype_t  VarIrec_MinIdx = 0;
    const SLOG_rectype_t  FixIrec_MinIdx = 1;
    const SLOG_rectype_t  FixIrec_MaxIdx = 5;

    SLOG_recdefs_buf     *slog_recdefs;
    SLOG_rectype_t        rectype;
    SLOG_N_assocs_t       Nassocs;
    SLOG_N_args_t         Nargs;
    int        ii, jj, idx_type;
    int        ierr;

    if ( argc > 1 ) {
        printf( "argc > 1 \n" );
        if ( isascii( argv[0][1] ) ) {   /*  isalpha() does NOT work  */
            printf( "argv[1] = %s\n", argv[1] );
            strcpy( filename, argv[1] );
            printf( "The new filename is %s\n", filename );
            /*  strcat( filename, "\0" );   */
        }
    }

    slog_recdefs = SLOG_RDEF_Open( filename );
    if ( slog_recdefs == NULL ) {
       printf( "SLOG_RDEF_Open( %s ) fails!\n", filename );
       exit( 1 );
    }


    /*  Create the Indexes for Variable Interval Record  */

    Nargs = 0;    /*  Initialization, does NOT mean anything  */
    for ( Nassocs = 0; Nassocs <= MaxAssocs; Nassocs++ ) {
        rectype = GetRecType( VarIrec_MinIdx, Nassocs, Nargs );
        ierr = SLOG_RDEF_AddRecDef( slog_recdefs, 
                                    rectype , Nassocs , Nargs );
        if ( ierr == SLOG_FAIL ) {
            printf( "SLOG_RDEF_AddRecDef() fails at rectype = "
                    fmt_rtype_t"\n", rectype );
            exit( 1 );
        }
    }


    /*  Create the Indexes for Fixed Interval Record  */

    for ( idx_type = FixIrec_MinIdx; idx_type <= FixIrec_MaxIdx; idx_type++ ) {
        for ( Nassocs = 0; Nassocs <= MaxAssocs; Nassocs++ ) {
            for ( Nargs = 0; Nargs <= MaxArgs; Nargs++ ) {
                rectype = GetRecType( idx_type, Nassocs, Nargs );
                ierr = SLOG_RDEF_AddRecDef( slog_recdefs, 
                                            rectype , Nassocs , Nargs );
                if ( ierr == SLOG_FAIL ) {
                    printf( "SLOG_RDEF_AddRecDef() fails at rectype = "
                            fmt_rtype_t"\n", rectype );
                    exit( 1 );
                }
            }
        }
    }

    ierr = SLOG_RDEF_Close( slog_recdefs );
    if ( ierr != SLOG_SUCCESS ) {
        printf( "SLOG_RDEF_Close() fails!\n" );
        exit( 1 );
    }
}
